# frozen_string_literal: true

require "parslet"
require "dwarves/parser/4/parser"
require "dwarves/parser/4/transformer"

module Dwarves
  module Parser
    # Parser to handle DWARF 4 format outputed by the following
    #
    # - `readelf --debug-dump=info`
    # - `objdump --dwarf=info`
    #
    class V4
      # @return [Hash] the parsed DWARF output
      def parse input
        V4Parser.new.parse input
      end

      def apply input
        V4Transformer.new.apply input
      end
    end
  end
end
